--***************************************************************
--Fich.:		canalesAsinc.ads
--Tema:		Implementaci'on un paquete generico de canales
--				para simular programas distribuidos. 
--				La comunicaci'on es as'incrona
--Fecha:		Mayo-02
--Fuente:	J. Ezpeleta
--Com.:
--***************************************************************
with listas;

generic
	type dato is private;
package canalesAsinc is
	package listaDato is new listas(dato);
	
	protected type canalAsinc is
		procedure send(d: in dato); --no bloqueante
		entry receive(d: out dato);
	private
		losEl: listaDato.lista := listaDato.listaVacia;
				--contenido del canal
	end canalAsinc;
private

end canalesAsinc;