--***************************************************************
--Fich.:		listas.ads
--Tema:		Especificaci'on de un paquete de listas gen'ericas
--Fecha:		Mayo-02
--Fuente:	J. Ezpeleta
--Com.:		Incompleto.
--          "Pre" en blanco es TRUE
--***************************************************************

generic
	type elemento is private;
package listas is
	type lista is private;
	type ptrNodo is private;
	type nodo is private;
	
	function listaVacia return lista;
	--Pre:
	--Post: listaVacia = []

	function esVacia(l: in lista) return boolean;
	--Pre:
	--Post: esVacia = (l=[])

	procedure anadeIzq(l: in out lista; e: in elemento);
	--Pre: l=[e_1 ... e_n]
	--Post: l=[e e_1 ... e_n]

	procedure eliminaIzq(l: in out lista);
	--Pre: l=[e_1 ... e_n], n>0
	--Post: l=[e_2 ... e_n]

	procedure anadeDch(l: in out lista; e: in elemento);
	--Pre:  l=[e_1 ... e_n]
	--Post: l=[e_1 ... e_n e]

	procedure eliminaDch(l: in out lista);
	--Pre: l=[e_1 ... e_n], n>0
	--Post: l=[e_1 ... e_{n-1}]

	function  long(l: in lista) return natural;
	--Pre: l=[e_1 ... e_n]
	--Post: long = n

	procedure libera(l: in out lista);
	--Pre:  l=[e_1 ... e_n]
	--Post: l=[]
	--Com: la memoria que ocupaba l ha sido liberada

	function observa(l: in lista;pos: natural) return elemento;
	--Pre: l=[e_1 ... e_n],1<=pos<=n
	--Post: observa = e_{pos}
	
private
	type nodo is record
		dato: elemento;
		sig: ptrNodo;
	end record;
	type ptrNodo is access nodo;
	type lista is record
		n: natural;
		pri,ult: ptrNodo;
	end record;
end listas;