/**
 * 4. prctica de Programacin Concurrente
 * 
 * @author      Miguel ngel Latre Abada
 * @version     1, 5-2011
 */
package practica4;

import java.util.*;

/**
 * Clase que simula un canal de comunicacin asncrona 
 * @author Latre
 *
 * @param <E> Tipo de datos transmitidos por el canal
 */
class CanalAsincrono<E> {

   /**
    * cola de mensajes asociada al canal
    */
	private Queue<E> colaCanal = new LinkedList<E>();
	
	/**
	 * Enva el mensaje <code>d</code> por este canal. No es bloqueante
	 * @param d mensaje que se desea enviar
	 */
	public synchronized void send(E d) {
		colaCanal.add(d);
		notifyAll();
	}
	
	/**
    * Suspende la ejecucin del thread que invoca este mtodo hasta
    * que haya al menos un mensaje en este canal y devuelve el primer 
    * mensaje pendiente de leer de este canal
    * @return El primer mensaje pendiente de leer de este canal
	 * @throws InterruptedException cuando el thread que invoca este
	 * mtodo es interrumpido
	 */
	public synchronized E receive() throws InterruptedException {
		while(colaCanal.isEmpty()) {
			wait();
		}
		// !colaCanal.isEmpty()
		return colaCanal.remove();
	}		
}